# (c) Copyright 2010 Cloudera, Inc.

import os
import tarfile
import logging

logger = logging.getLogger()

def create_tar(tar_path, tar_output_dir=None):
    """
    Given a directory path containing files for each command, create a tarball in
    the tar_output_dir. If tar_output_path is None, it is the current working
    directory.
    """
    output_basename = os.path.basename(tar_path)

    tarball_name = "%s.tar.gz" % output_basename
    if tar_output_dir is None:
        tar_output_path = os.path.join(os.getcwd(), tarball_name)
    else:
        tar_output_path = os.path.join(tar_output_dir, tarball_name)

    tar = tarfile.open(name=tar_output_path, mode="w:gz")
    tar.add(tar_path, arcname=output_basename)
    tar.close()

    logger.info("Wrote tarball to %s" % tar_output_path)
    return tar_output_path
