# (c) Copyright 2011 Cloudera, Inc.

class LogEvent(object):
    """Represents a log event. Encapsulates the file, offset in the file, as
    welll as the datetime, log level, source and log message of that log
    event."""

    def __init__(self, file_path, offset, end_offset, date_time, log_level, source, message):
        self.__file_path = file_path
        self.__offset = offset
        self.__end_offset = end_offset
        self.__date_time = date_time
        self.__log_level = log_level
        self.__source = source
        self.__message = message

    def get_file_path(self):
        return self.__file_path

    def get_offset(self):
        return self.__offset

    def get_end_offset(self):
        return self.__end_offset

    def get_datetime(self):
        return self.__date_time

    def get_log_level(self):
        return self.__log_level

    def get_source(self):
        return self.__source

    def get_message(self):
        return self.__message

    def append_to_message(self, message):
        if self.__message is None:
            self.__message = message
        else:
            self.__message += message
        self.__end_offset += len(message)

    def __str__(self):
        date_string = self.__date_time.strftime("%Y-%m-%d %H:%M:%S,")
        date_string += str(self.__date_time.microsecond/1000)
        return date_string + " " + self.__log_level + " " + self.__source + \
            ": " + self.__message
        
