# (c) Copyright 2011 Cloudera, Inc.

import os

class LogFile(object):
    """Represents a log file. Encapsulates the path, as well as the portion of the
    file that is relevant."""

    def __init__(self, path, start_offset=None, end_offset=None):
        self.__path = path
        if start_offset is None:
            self.__start_offset = 0
        else:
            self.__start_offset = start_offset

        if end_offset is None:
            self.__end_offset = os.stat(path).st_size
        else:
            self.__end_offset = end_offset
        self.__handle = None

    def get_path(self):
        return self.__path

    def set_path(self, path):
        self.__path = path

    def get_start_offset(self):
        return self.__start_offset

    def set_start_offset(self, offset):
        self.__start_offset = offset

    def get_end_offset(self):
        return self.__end_offset

    def set_end_offset(self, offset):
        self.__end_offset = offset

    def open_log_file(self):
        handle = open(self.__path)
        handle.seek(self.__start_offset)
        self.__handle = handle
        return handle

    def get_handle(self):
        return self.__handle
