# (c) Copyright 2010 Cloudera, Inc.

import unittest
import clusterstats.common.chain as chain

class TestChain(unittest.TestCase):

    def test_build_chain(self):
        def func1(context):
            context["func1"] = True
            return True
        def func2(context):
            context["func2"] = True
            return True

        c = chain.build_chain([func1, func2])
        context = {"start": True}
        self.assertTrue(c(context))
        self.assertTrue(context["func1"])
        self.assertTrue(context["func2"])
        self.assertTrue(context["start"])

    def test_chain_failure(self):
        def func1(context):
            context["func1"] = True
            return False
        def func2(context):
            context["func2"] = True
            return True

        c = chain.build_chain([func1, func2])
        context = {"start": True}
        self.assertFalse(c(context))
        self.assertTrue(context["func1"])
        self.assertFalse("func2" in context)
        self.assertTrue(context["start"])

    def test_ok_command(self):
        def func1(context):
            return True
        def ok_command(context, context2=None):
            return True
        c = chain.build_chain([func1, ok_command])
