# (c) Copyright 2010 Cloudera, Inc.

import os
import sys
import unittest
import clusterstats.common.configuration as configuration

class TestConfiguration(unittest.TestCase):

    def setUp(self):
        localdir = os.path.dirname(__file__)
        if localdir in sys.path:
            sys.path.remove(localdir)
        configuration.configs = {}

    def test_get_nonexistent_config(self):
        self.assertRaises(ValueError, configuration.get_config, "something")

    def test_initialize_config_default_only(self):
        config = configuration.initialize_config("test", __file__)
        self.assertEqual("1", config.get("foo"))
        self.assertEqual("2", config.get("bar"))

    def test_initialize_config_default_site(self):
        sys.path.append(os.path.dirname(__file__))
        config = configuration.initialize_config("test", __file__)
        self.assertEquals("1", config.get("foo"))
        self.assertEquals("3", config.get("bar"))

    def test_initialize_and_get_config(self):
        config1 = configuration.initialize_config("test", __file__)
        config2 = configuration.get_config("test")
        self.assertEquals(config1, config2)

if __name__ == '__main__':
    unittest.main()
