# (c) Copyright 2010 Cloudera, Inc.

import os
import tempfile
import unittest
import shutil
import clusterstats.common.tar as tar

class TestTar(unittest.TestCase):

    def test_create_tar(self):
        tempdir = tempfile.mkdtemp()
        try:
            tardir = os.path.join(tempdir, "tardir")
            os.mkdir(tardir)

            one_file = os.path.join(tardir, "one.txt")
            two_file = os.path.join(tardir, "two.txt")

            one = open(one_file, "w")
            one.write("1")
            one.close()

            two = open(two_file, "w")
            two.write("2")
            two.close()

            tar_path = tar.create_tar(tardir)
            try:
                self.assertEquals(os.path.join(os.getcwd(), "tardir.tar.gz"), tar_path)
            finally:
                os.remove(tar_path)

            tar_path = tar.create_tar(tardir, tempdir)
            try:
                self.assertEquals(os.path.join(tempdir, "tardir.tar.gz"), tar_path)
            finally:
                os.remove(tar_path)
        finally:
            shutil.rmtree(tempdir)

