# Copyright (c) 2012 Cloudera, Inc. All rights reserved.
from __future__ import absolute_import

# This file ought to be generated instead of maintained by hand. We also out to
# move the self-developed JMX bean name definitions (e.g. the various MGMT role
# bean names) into this file from jmx_beans.py. OPSAPS-7431 tracks doing this
# work.

# Constant values for the WEB_METRICS_COLLECTION_STATUS metric.
WEB_METRICS_COLLECTION_GOOD = 1
WEB_METRICS_COLLECTION_COMMUNICATION_FAILURE = 2
WEB_METRICS_COLLECTION_PARSE_FAILURE = 3

# Constants values corresponding to the java FileMetricsCollectionStatus
FILE_METRICS_COLLECTION_UNKNOWN = 0
FILE_METRICS_COLLECTION_GOOD = 1
FILE_METRICS_COLLECTION_FILE_NOT_FOUND = 2
FILE_METRICS_COLLECTION_PARSE_FAILURE = 3
FILE_METRICS_COLLECTION_STALE_SAMPLE = 4

# Version for the agent. This is used to detect out of date agents.
# This should be updated when the version changes. See bump_version.sh
AGENT_VERSION = "6.3.1"

SERVICE_VERSION_CDH5 = 5
SERVICE_VERSION_CDH6 = 6

VERSION_STRINGS = dict({ SERVICE_VERSION_CDH5 : 'cdh5',
                         SERVICE_VERSION_CDH6 : 'cdh6' })

# The default throttling log rate for the different monitors. Once an hour.
DEFAULT_MONITOR_LOG_RATE= 60 * 60

# These are matched in the java code in HostNTPStatus.
NTP_STATUS_UNKNOWN = 0
NTP_STATUS_RUNNING = 1
NTP_STATUS_UNREACHEABLE = 2
NTP_STATUS_NOT_SYNCHRONIZED = 3

# This is matched with TimeSeriesAttributeName AGENT_NAME.
AGENT_NAME = "agentName"

# Constant values for the SOLR_CORE_STATUS_COLLECTION_STATUS metric.
SOLR_CORE_STATUS_COLLECTION_GOOD = 1
SOLR_CORE_STATUS_COLLECTION_COMMUNICATION_FAILURE = 2
SOLR_CORE_STATUS_COLLECTION_PARSE_FAILURE = 3

# Pause info related constants. This allows us to handle pause metrics
# with different names easily. See json_metrics_utils for more details.
PAUSE_BEAN_ATTR_NAME = "cm_pause_metric_name"
PAUSE_TIME_ALIAS = "pause_time_ms"
PAUSES_ALIAS = "pauses"

# Constant value from ImpalaDaemonReadyState.
IMPALA_DAEMON_READY_STATE_UNKNOWN = 0

# Constant value for date format.
DATE_FORMAT = '%d/%b/%Y %H:%M:%S %z'

# The kernel virtual memory accounting mode. Matched in the java code in
# HostOvercommitMode
OVERCOMMIT_UNKNOWN = -1
OVERCOMMIT_HEURISTIC = 0
OVERCOMMIT_NO_CHECK = 1
OVERCOMMIT_ALWAYS_CHECK = 2

# Constant values for the DNS_RESOLUTION_DURATION metric. Corresponds to the
# DnsResolutionStatus enum in java.
DNS_RESOLUTION_STATUS_ERROR = 0
DNS_RESOLUTION_STATUS_MISMATCH = 1
DNS_RESOLUTION_STATUS_MATCH = 2
DNS_RESOLUTION_STATUS_SUBPROCESS_FAILED = 3

# This is defined on the java side in DualThreshold.
NEVER = "-2.0"

MAX_SIGNED_INTEGER = (1 << 31) - 1

# Duplex, half or full. Must be in sync with the values of the enum DuplexMode
# defined at HostSlowNetworkInterfaceCounter.
DUPLEX_HALF = 0
DUPLEX_FULL = 1
DUPLEX_UNKNOWN = MAX_SIGNED_INTEGER
