# Copyright (c) 2014 Cloudera, Inc. All rights reserved.
from __future__ import absolute_import

try:
  from cStringIO import StringIO
except:
  from StringIO import StringIO

import time

import cmf.monitor.constants as constants

class ImpalaDaemonUpdate(object):
  """
  This models the ImpalaDaemonUpdate Avro record and gives it a bit more
  structure.
  """
  def __init__(self):

    self._ready = constants.IMPALA_DAEMON_READY_STATE_UNKNOWN
    self._pool_updates = []

  def set_ready(self, ready):
    self._ready = ready
    return self

  def add_pool_update(self, pool_update):
    self._pool_updates.append(pool_update)
    return self

  def to_avro_dict(self):
    """Return a Python dictionary that maps to the Avro struct"""
    return dict(ready=self._ready,
                poolUpdates=[ u.to_avro_dict() for u in self._pool_updates ])
