# Copyright (c) 2015 Cloudera, Inc. All rights reserved.
from __future__ import absolute_import

def get_urlopen_retries_on_auth_errors(safety_valve):
  """
  Returns the number of times to retry urlopen calls that are failing with
  authentication errors.
  """
  if safety_valve is None:
    raise Exception("A safety valve is required!")

  default = 2
  key = "urlopen_retries_on_auth_errors"
  retries = safety_valve.get(key, str(default))
  try:
    return int(retries)
  except:
    THROTTLED_LOG.exception("Failed to parse %s: %s. Using %d." %
                            (key, retries, default))
    return default

def get_urlopen_sleep_seconds_on_auth_errors(safety_valve):
  """
  Returns the amount of time to sleep before retrying a urlopen call that has
  failed with an authentication error.
  """
  if safety_valve is None:
    raise Exception("A safety valve is required!")

  default = 1.0
  key = "urlopen_sleep_seconds_on_auth_errors"
  sleeptime = safety_valve.get(key, str(default))
  try:
    return float(sleeptime)
  except:
    THROTTLED_LOG.exception("Failed to parse %s: %s. Using %f." %
                            (key, sleeptime, default))
    return default
