# Copyright (c) 2011-2012 Cloudera, Inc. All rights reserved.
from __future__ import absolute_import
import base64

try:
  from cStringIO import StringIO
except:
  from StringIO import StringIO

import avro.io
import avro.protocol

import cmf
from cmf.monitor.host_update import HostUpdate
from cmf.monitor.fs_update import FsUpdate
from cmf.monitor.nic_update import NicUpdate
from cmf.monitor.disk_update import DiskUpdate

def make_dummy_agent_msg():
  hostupdate = HostUpdate(timestamp=10000).\
      add_metric(metricid=1, value=1).\
      add_fs_update(FsUpdate('/vol1', '/dev/sda1').\
                    add_metric(metricid=1, value=1)).\
      add_nic_update(NicUpdate('eth0').
                     add_metric(metricid=1, value=1)).\
      add_disk_update(DiskUpdate('/dev/sda1').
                      add_metric(metricid=1, value=1))
  return dict(ts_secs=10000,
              hostname="host1",
              attempt_metrics=[],
              host_update=hostupdate.to_avro_dict(),
              service_updates=[],
              role_metrics=[],
              host_id="host1")

def write_fake_msg():
  msg_buffer = StringIO()

  # Encode version
  sio = StringIO()
  encoder = avro.io.BinaryEncoder(sio)
  encoder.write_int(cmf.monitor.firehose.AGENT_PROTOCOL_VERSION)
  msg_buffer.write(sio.getvalue())

  # Encode the message
  sio = StringIO()
  encoder = avro.io.BinaryEncoder(sio)
  agent_msg_schema = avro.protocol.parse(file(cmf.monitor.CMON_AGENT_AVPR).read()) \
                         .types_dict.get('AgentMessages')
  datum_writer = avro.io.DatumWriter(agent_msg_schema)
  agentmsg = make_dummy_agent_msg()
  agentmsgs = [ ]
  agentmsgs.append(agentmsg)
  agent_messages = dict(agent_msgs=agentmsgs)
  datum_writer.write(agent_messages, encoder)
  msg_buffer.write(sio.getvalue())

  print "Dummy agent message base64 data:"
  print base64.b64encode(msg_buffer.getvalue())

if __name__ == '__main__':
    write_fake_msg()
