# Copyright (c) 2013 Cloudera, Inc. All rights reserved.

import os
import tempfile
import shutil

from cmf.monitor import conf

def make_config_file(content):
  """
  Creates a cloudera-monitor.properties file in a tmp directory,
  and return the absolute path to that directory.
  """
  conf_dir = tempfile.mkdtemp(suffix='.scm-agent-test')
  try:
    path = os.path.join(conf_dir, conf.CLOUDERA_MONITOR_PROPERTIES)
    file(path, 'w').write(content)
    return conf_dir
  except:
    shutil.rmtree(conf_dir)
    raise
