# Copyright (c) 2015 Cloudera, Inc. All rights reserved.
from __future__ import absolute_import, print_function

import re

def expandRangeList(rangedSpec):
  '''
  Expand range patterns in a string of the form {x,y,z}, {x..z}, {x,y,z..a}.
  Note: given "a..b", it is expected that a<b
  :param rangedSpec:
  :return:
  '''
  baseRe = re.compile("^([^\{]*)\{([^\}]*)\}(.*)$")
  m = baseRe.match(rangedSpec)
  if m is None:
    return [rangedSpec]
  prefix = m.group(1)
  r = m.group(2)
  tail = m.group(3)
  result = []
  items = r.split(",")
  for x in items:
    s = x.partition("..")
    if len(s[1]) > 0:
      begin = int(s[0])
      end = int(s[2])
    else:
      begin = int(s[0])
      end = begin
    for y in range(begin, end + 1):
      result.append("%s%s%s" % (prefix, y, tail))
  return result

if __name__ == "__main__":
  print(expandRangeList("abcd-{1,2,3..5}-tail"))
