#! /usr/bin/env bash
# Copyright (c) 2018 Cloudera, Inc. All rights reserved.

set -ex

# Time marker for both stderr and stdout
date; date 1>&2

# More conservative umask for logs, indexes, and such.
umask 027

cloudera_config=$(dirname $0)
cloudera_config=$(cd "$cloudera_config/../common"; pwd)
. ${cloudera_config}/cloudera-config.sh

# attempt to find java
locate_java_home

# Search-replace {{CMF_CONF_DIR}} in files
replace_conf_dir

# Load the parcel environment
source_parcel_environment

# Chmod scripts so they can run
make_scripts_executable

# Send these off to keycloak.sh:
export KEYCLOAK_PROPERTIES="${CONF_DIR}/keycloak.properties"
export KEYCLOAK_DIR="${PARCELS_ROOT}/keycloak"

echo "Transferring control to ${KEYCLOAK_DIR}/cloudera_keycloak.sh"
exec ${KEYCLOAK_DIR}/cloudera_keycloak.sh
