#!/bin/bash
# Copyright (c) 2012 Cloudera, Inc. All rights reserved.

# Usage is test_db_connection.sh <db_properties_file>
#
# Code to setup environment variables (including JAVA_HOME) is copied
# from mgmt/mgmt.sh

set -e
set -x

# Time marker for both stderr and stdout
date; date 1>&2

cloudera_config=`dirname $0`
cloudera_config=`cd "$cloudera_config/../common"; pwd`
. ${cloudera_config}/cloudera-config.sh

# attempt to find java, method exits if it can't find java
locate_java_home

# Load the parcel environment
source_parcel_environment

JAVA="$JAVA_HOME/bin/java"

if [[ -z "$MGMT_HOME" ]]; then
  echo "\$MGMT_HOME" is not set.
  exit 1
fi

# "*" is interpreted by Java, to mean all jars in dir.
MGMT_CLASSPATH="$MGMT_HOME/lib/*"

JDBC_JARS="$CLOUDERA_MYSQL_CONNECTOR_JAR:$CLOUDERA_POSTGRESQL_JDBC_JAR:$CLOUDERA_ORACLE_CONNECTOR_JAR"
MGMT_CLASSPATH="${JDBC_JARS}:${MGMT_CLASSPATH}"

# Current directory has the db config file
MGMT_CLASSPATH="$(pwd):$MGMT_CLASSPATH"

# Disable IPv6.
MGMT_JAVA_OPTS="-Djava.net.preferIPv4Stack=true $MGMT_JAVA_OPTS"

# $1 should be the name of the db configuration file (either cmon.conf or headlamp.db.properties)
exec ${JAVA} ${MGMT_JAVA_OPTS} -Djava.security.egd=file:///dev/urandom -cp "${MGMT_CLASSPATH}" com.cloudera.enterprise.dbutil.DbCommandExecutor $1
