#!/bin/bash

# Copyright (c) 2017 Cloudera, Inc. All rights reserved.
#
# Base for all distcp commands including precopylisting, copylisting and distcp

# Time marker for both stderr and stdout
date; date 1>&2

# debug
set -x
echo "Running on: $(hostname -f) ($(hostname -i))"

cloudera_config=`dirname $0`
cloudera_config=`cd "$cloudera_config/../common"; pwd`
. ${cloudera_config}/cloudera-config.sh

# load the parcel environment
source_parcel_environment

# attempt to find java
locate_cdh_java_home

# simulate /etc/default/hadoop if necessary
. ${cloudera_config}/cdh-default-hadoop

echo "using $JAVA_HOME as JAVA_HOME"
echo "using $CDH_VERSION as CDH_VERSION"
echo "using $CONF_DIR as CONF_DIR"

set_hadoop_classpath

replace_conf_dir

# Disable IPv6.
export HADOOP_OPTS="-Djava.net.preferIPv4Stack=true $HADOOP_OPTS"

acquire_kerberos_tgt hdfs.keytab

ACLLIB_CLASSPATH=`echo ${MGMT_HOME}/lib/dr/distcp_acllib-*.jar`
export HADOOP_CLASSPATH="$ACLLIB_CLASSPATH:$HADOOP_CLASSPATH"
