#!/bin/bash

# Copyright (c) 2012 Cloudera, Inc. All rights reserved.
#
# Runs custom distcp jar.  Currently only
# works with CDH4's MR1.

current_dir=`dirname $0`
. ${current_dir}/distcp-base.sh

if [ "MAPREDUCE" = "$MAPREDUCE_SERVICE_TYPE" ]; then
  MR_CONF_DIR=${CONF_DIR}/hadoop-conf
  HADOOP_HOME=${CDH_MR1_HOME}
  echo "using $CDH_MR1_HOME as CDH_MR1_HOME"
  perl -pi -e "s#\{\{CDH_MR1_HOME}}#$CDH_MR1_HOME#g" $MR_CONF_DIR/*
elif [ "YARN" = "$MAPREDUCE_SERVICE_TYPE" ]; then
  MR_CONF_DIR=${CONF_DIR}/yarn-conf
  HADOOP_HOME=${CDH_HADOOP_HOME}
  echo "using $CDH_MR2_HOME as CDH_MR2_HOME"
  perl -pi -e "s#\{\{CDH_MR2_HOME}}#$CDH_MR2_HOME#g" $MR_CONF_DIR/*
else
  echo "Invalid value for MAPREDUCE_SERVICE_TYPE: $MAPREDUCE_SERVICE_TYPE"
  exit 1
fi

exec ${HADOOP_HOME}/bin/hadoop --config ${MR_CONF_DIR} jar ${MGMT_HOME}/lib/dr/distcp-*.jar -libjars ${MGMT_HOME}/lib/dr/distcp_acllib-*.jar "$@"
