#!/usr/bin/env python
# Copyright (c) 2011 Cloudera, Inc. All rights reserved.
"""
Single-threaded web server that prints "hello world" to all
comers.
"""
import logging
from BaseHTTPServer import HTTPServer, BaseHTTPRequestHandler
import sys
import os

# Global, for ease.
greeting = "Hello (default greeting)"

class GetHandler(BaseHTTPRequestHandler):
  def do_GET(self):
    global greeting
    self.send_response(200)
    self.end_headers()
    self.wfile.write("<br>User: %s Group: %s" % (os.getuid(), os.getgid(),))
    self.wfile.write("<h1>%s</h1>Path: %s" % (greeting, self.path))
    try:
      self.wfile.write("<br>Local 'config' file contents: " + file("/tmp/config").read())
    except:
      self.wfile.write("<br>No local config file found.")
    return

if __name__ == '__main__':
  global greeting
  if sys.argv[1:]:
    greeting = " ".join(sys.argv[1:])
  logging.basicConfig(level=logging.INFO)
  try:
    port = int(file("hello.conf").read())
  except:
    port = 9876
  logging.info("Listening on port %d." % (port,))
  server = HTTPServer(('', port), GetHandler)
  server.serve_forever()
