#!/bin/bash
# Copyright (c) 2016 Cloudera, Inc. All rights reserved.

# Fix for OPSAPS-33991
# this is based on common/killparent.sh

# Enable tracing
set -x

# default target process
TARGET=$PPID

# If dash is the system shell, there is an extra process between us and the
# JVM we want to kill
grep -q "impala-CATALOGSERVER" /proc/$PPID/cmdline
RET=$?

if [ $RET -ne 0 ]; then
  # Get the grandparent PID
  GRAND_PARENT_PID=`ps -p $PPID -o ppid=`
  grep -q "impala-CATALOGSERVER" /proc/$GRAND_PARENT_PID/cmdline
  RET=$?
  if [ $RET -eq 0 ]; then
    TARGET=$GRAND_PARENT_PID
  else
    echo "`basename $0`: Couldn't find parent process to kill"
    exit 1
  fi
fi

echo `date` > killed_by_killparent_on_oom
kill -9 $TARGET
