#!/bin/bash
# Copyright (c) 2014 Cloudera, Inc. All rights reserved.
#
# Runs jmap -dump against a process, directing the output to a file and then
# gzipping the output.
#
# arg1: pid
# arg2: output filename (the file will end up as $2.gz). Any previous file with
#       the name $2.gz will be removed.
# arg3: symlink name, a symlink to the produced $2.gz wil be placed in this
#       directory under this name

cloudera_config=`dirname $0`
cloudera_config=`cd "$cloudera_config/../common"; pwd`
. ${cloudera_config}/cloudera-config.sh

locate_java_home

set -e

if [ -e $JAVA_HOME/bin/jmap ]; then
  rm -f "$2.gz"
  $JAVA_HOME/bin/jmap -dump:format=b,file="$2" "$1" 2>&1
  gzip "$2"
  ln -s "$2.gz" "$3"
  exit 0
fi

echo "Missing $JAVA_HOME/bin/jmap" 1>&2
exit 1
