#!/bin/bash

# Copyright (c) 2016 Cloudera, Inc. All rights reserved.

# Time marker for both stderr and stdout
date; date 1>&2

set -x

PROCESS_DIR_NAME=$(basename $(pwd))
METRICS_DUMP_FILE="$HEAP_DUMP_DIR/$PROCESS_DIR_NAME.tar.gz"
storage_dir=$1

# We are forced to compress since diagnostics_linked_data requires
# filenames to have a "gz" suffix.  Use the lowest compression level
# since the data is already mostly compressed.
GZIP=-1 tar zcf $METRICS_DUMP_FILE -C $storage_dir .

# A symlink called output.gz to the real file is required for
# handling of diagnostics_linked_data.  See status_server.py.
ln -s $METRICS_DUMP_FILE output.gz

